(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/common/http'), require('lodash'), require('@angular/core'), require('@angular/router'), require('@auth0/angular-jwt'), require('ngforage')) :
    typeof define === 'function' && define.amd ? define('api-lib', ['exports', '@angular/common', '@angular/common/http', 'lodash', '@angular/core', '@angular/router', '@auth0/angular-jwt', 'ngforage'], factory) :
    (factory((global['api-lib'] = {}),global.ng.common,global.ng.common.http,global._,global.ng.core,global.ng.router,global.angularJwt,global.ngforage));
}(this, (function (exports,common,http,_,core,router,angularJwt,ngforage) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var HttpMethods = {
        GET: 'GET',
        POST: 'POST',
        PUT: 'PUT',
        PATCH: 'PUT',
        DELETE: 'DELETE',
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EnvironmentConfigService = new core.InjectionToken('EnvironmentConfig');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var methodsWithBody = [HttpMethods.POST, HttpMethods.PUT, HttpMethods.PATCH];
    /** @type {?} */
    var uploadingSection = ['media'];
    var HttpService = /** @class */ (function () {
        function HttpService(config, http$$1) {
            this.config = config;
            this.http = http$$1;
        }
        /**
         * @private
         * @param {?} urlParams
         * @param {?} method
         * @param {?} options
         * @return {?}
         */
        HttpService.prototype.handle = /**
         * @private
         * @param {?} urlParams
         * @param {?} method
         * @param {?} options
         * @return {?}
         */
            function (urlParams, method, options) {
                options = this.filterParams(urlParams, options);
                if (methodsWithBody.indexOf(method) === -1) {
                    options = {
                        params: new http.HttpParams({
                            fromObject: options
                        })
                    };
                }
                /** @type {?} */
                var request = new http.HttpRequest(method, this.buildUrl(urlParams), options, {
                    responseType: urlParams.responseType || 'json'
                });
                // add header to prevent token checking for public requests
                if (urlParams.insecure === true) {
                    request = request.clone({ setHeaders: { Insecure: '1' } });
                    delete urlParams.insecure;
                }
                return this.http.request(request)
                    .toPromise()
                    .then(( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                    // console.log('response', event);
                    return {
                        result: true,
                        data: (urlParams.rawResponse === true) ? event : event.body
                    };
                }))
                    .catch(( /**
             * @param {?} error
             * @return {?}
             */function (error) {
                    return {
                        result: false,
                        error: (urlParams.rawResponse === true) ? error : error.error
                    };
                }));
            };
        /**
         * @param {?} urlParams
         * @param {?=} params
         * @return {?}
         */
        HttpService.prototype.get = /**
         * @param {?} urlParams
         * @param {?=} params
         * @return {?}
         */
            function (urlParams, params) {
                if (params === void 0) {
                    params = {};
                }
                return this.handle(urlParams, HttpMethods.GET, params);
            };
        /**
         * @param {?} urlParams
         * @param {?=} params
         * @return {?}
         */
        HttpService.prototype.search = /**
         * @param {?} urlParams
         * @param {?=} params
         * @return {?}
         */
            function (urlParams, params) {
                if (params === void 0) {
                    params = {};
                }
                return this.handle(urlParams, HttpMethods.GET, params);
            };
        /**
         * @param {?} urlParams
         * @param {?} data
         * @return {?}
         */
        HttpService.prototype.save = /**
         * @param {?} urlParams
         * @param {?} data
         * @return {?}
         */
            function (urlParams, data) {
                return this.handle(urlParams, HttpMethods.POST, data);
            };
        /**
         * @param {?} urlParams
         * @param {?} data
         * @return {?}
         */
        HttpService.prototype.update = /**
         * @param {?} urlParams
         * @param {?} data
         * @return {?}
         */
            function (urlParams, data) {
                return this.handle(urlParams, HttpMethods.PUT, data);
            };
        /**
         * @param {?} urlParams
         * @param {?=} params
         * @return {?}
         */
        HttpService.prototype.delete = /**
         * @param {?} urlParams
         * @param {?=} params
         * @return {?}
         */
            function (urlParams, params) {
                if (params === void 0) {
                    params = {};
                }
                return this.handle(urlParams, HttpMethods.DELETE, params);
            };
        /**
         * Transform keys to `key[]` for array type vales
         * and remove params with empty values
         * @param urlParams
         * @param options
         */
        /**
         * Transform keys to `key[]` for array type vales
         * and remove params with empty values
         * @private
         * @param {?} urlParams
         * @param {?} options
         * @return {?}
         */
        HttpService.prototype.filterParams = /**
         * Transform keys to `key[]` for array type vales
         * and remove params with empty values
         * @private
         * @param {?} urlParams
         * @param {?} options
         * @return {?}
         */
            function (urlParams, options) {
                /** @type {?} */
                var params = {};
                _.forOwn(options, ( /**
                 * @param {?} value
                 * @param {?} key
                 * @return {?}
                 */function (value, key) {
                    if (_.isArray(value) && key.indexOf('[]') === -1) {
                        key += '[]';
                    }
                    if (value !== null && value !== undefined) {
                        params[key] = value;
                    }
                }));
                // convert boolean values to numeric except media content
                if (uploadingSection.indexOf(urlParams.section) === -1) {
                    params = _.mapValues(params, ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return _.isBoolean(value) ? +value : value; }));
                }
                return params;
            };
        /**
         * Make url like `/section/id/cmd/secondId`
         * @param urlParams
         */
        /**
         * Make url like `/section/id/cmd/secondId`
         * @private
         * @param {?} urlParams
         * @return {?}
         */
        HttpService.prototype.buildUrl = /**
         * Make url like `/section/id/cmd/secondId`
         * @private
         * @param {?} urlParams
         * @return {?}
         */
            function (urlParams) {
                /** @type {?} */
                var url = [this.config.url + "/" + urlParams.section];
                if (urlParams.id !== undefined) {
                    url.push("" + urlParams.id);
                }
                if (urlParams.cmd) {
                    url.push("" + urlParams.cmd);
                }
                if (urlParams.secondId) {
                    url.push("" + urlParams.secondId);
                }
                return url.join('/');
            };
        HttpService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        HttpService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: core.Inject, args: [EnvironmentConfigService,] }] },
                { type: http.HttpClient }
            ];
        };
        return HttpService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _$$1 = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_$$1)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _$$1.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _$$1.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _$$1.ops.pop();
                            _$$1.trys.pop();
                            continue;
                        default:
                            if (!(t = _$$1.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _$$1 = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _$$1.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _$$1.label < t[1]) {
                                _$$1.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _$$1.label < t[2]) {
                                _$$1.label = t[2];
                                _$$1.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _$$1.ops.pop();
                            _$$1.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _$$1);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AuthService = /** @class */ (function () {
        function AuthService(httpService, router$$1, storageService) {
            this.httpService = httpService;
            this.router = router$$1;
            this.storageService = storageService;
            this.jwtHelper = new angularJwt.JwtHelperService();
            this._user = null;
        }
        /**
         * @return {?}
         */
        AuthService.prototype.getToken = /**
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.storageService.getItem('jwt')];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                });
            };
        /**
         * @param {?} token
         * @return {?}
         */
        AuthService.prototype.setToken = /**
         * @param {?} token
         * @return {?}
         */
            function (token) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.storageService.setItem('jwt', token)];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                });
            };
        /**
         * Set current logged user
         * @param {User} user
         */
        /**
         * Set current logged user
         * @param {?} user
         * @return {?}
         */
        AuthService.prototype.setUser = /**
         * Set current logged user
         * @param {?} user
         * @return {?}
         */
            function (user) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.storageService.setItem('user', user)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                });
            };
        /**
         * @return {?}
         */
        AuthService.prototype.getUser = /**
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var user;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!!this._user)
                                    return [3 /*break*/, 2];
                                return [4 /*yield*/, this.storageService.getItem('user')];
                            case 1:
                                user = _a.sent();
                                this._user = user;
                                return [2 /*return*/, user];
                            case 2: return [2 /*return*/, this._user];
                        }
                    });
                });
            };
        /**
         * Check if current user is authenticated
         * @return {boolean}
         */
        /**
         * Check if current user is authenticated
         * @return {?}
         */
        AuthService.prototype.isAuthenticated = /**
         * Check if current user is authenticated
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var token;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.getToken()];
                            case 1:
                                token = _a.sent();
                                return [2 /*return*/, token !== null && !this.isExpired()];
                        }
                    });
                });
            };
        /**
         * Check if token is expired
         * @return {boolean}
         */
        /**
         * Check if token is expired
         * @return {?}
         */
        AuthService.prototype.isExpired = /**
         * Check if token is expired
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var token;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.getToken()];
                            case 1:
                                token = _a.sent();
                                return [2 /*return*/, token !== null && this.jwtHelper.isTokenExpired(token)];
                        }
                    });
                });
            };
        /**
         * Attempt to refresh token
         * @return {Promise<string>}
         */
        /**
         * Attempt to refresh token
         * @return {?}
         */
        AuthService.prototype.refreshToken = /**
         * Attempt to refresh token
         * @return {?}
         */
            function () {
                var _this = this;
                return this.httpService
                    .search({
                    section: 'auth',
                    cmd: 'refresh',
                    rawResponse: true,
                    insecure: true
                })
                    .then(( /**
             * @param {?} response
             * @return {?}
             */function (response) {
                    return __awaiter(_this, void 0, void 0, function () {
                        var newToken, claims;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!response.result)
                                        return [3 /*break*/, 3];
                                    newToken = response.data.headers.get('authorization').split(' ')[1];
                                    claims = this.jwtHelper.decodeToken(newToken);
                                    return [4 /*yield*/, this.setUser(claims.user)];
                                case 1:
                                    _a.sent();
                                    return [4 /*yield*/, this.setToken(newToken)];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/, newToken];
                                case 3: return [2 /*return*/, ''];
                            }
                        });
                    });
                }));
            };
        /**
         * Clear all session variables
         */
        /**
         * Clear all session variables
         * @return {?}
         */
        AuthService.prototype.logout = /**
         * Clear all session variables
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                this._user = null;
                                return [4 /*yield*/, this.storageService.removeItem('jwt')];
                            case 1:
                                _a.sent();
                                return [4 /*yield*/, this.storageService.removeItem('user')];
                            case 2:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                });
            };
        AuthService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AuthService.ctorParameters = function () {
            return [
                { type: HttpService },
                { type: router.Router },
                { type: ngforage.NgForage }
            ];
        };
        return AuthService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApiLibModule = /** @class */ (function () {
        function ApiLibModule(parentModule) {
            if (parentModule) {
                throw new Error('ApiModule is already loaded. Import it in the AppModule only');
            }
        }
        /**
         * @param {?} config
         * @return {?}
         */
        ApiLibModule.forRoot = /**
         * @param {?} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: ApiLibModule,
                    providers: [
                        { provide: EnvironmentConfigService, useValue: config },
                        { provide: HttpService, useClass: 'ApiHttpService' },
                        { provide: AuthService, useClass: 'ApiAuthService' },
                    ]
                };
            };
        ApiLibModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [
                            common.CommonModule
                        ],
                        exports: []
                    },] }
        ];
        /** @nocollapse */
        ApiLibModule.ctorParameters = function () {
            return [
                { type: ApiLibModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
            ];
        };
        return ApiLibModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ApiLibModule = ApiLibModule;
    exports.ɵc = AuthService;
    exports.ɵa = EnvironmentConfigService;
    exports.ɵb = HttpService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=api-lib.umd.js.map